# coding: utf8
#On charge un fonds d'écran
#On charge un sprite png 180x90
#composé de deux images 90x90
#l'une est un vaisseau sans flamme d'éjection de gaz
#l'autre avec des flammes d'éjection de gaz
#L'image est repérée par son CSG


#-----------------------------LIBRAIRIES------------------------------
import pygame, sys, random, math
from pygame.locals import *

#------------------------VARIABLES-----------------------------------
LARGEUR                 = 800
HAUTEUR                = 500
NOIR                         = (0,0,0)
LARGEUR_IMAGE  = 90
HAUTEUR_IMAGE  = 90
#--------------------------------------------------------------
position                          = [(LARGEUR-LARGEUR_IMAGE)/2 ,(HAUTEUR-HAUTEUR_IMAGE)/2 ]
direction                        = 0

vitesse                            = [0,0]
acceleration                   = 1
vitesse_angulaire          = 2
coefficient_friction        = 0.99
accelere                          = False
tourneAGauche             = False
tourneADroite               = False


#-----------------------------------FONCTIONS-----------------------------------------------

def vecteurAcceleration(direction):
	return [acceleration*math.cos(math.radians(direction)),acceleration*math.sin(math.radians(direction))]
	
#-------------------------------------------------------------------------------------------------
def rot_center(image, angle):
    """rotate an image while keeping its center and size"""
    orig_rect = image.get_rect()
    rot_image = pygame.transform.rotate(image, angle)
    rot_rect = orig_rect.copy()
    rot_rect.center = rot_image.get_rect().center
    rot_image = rot_image.subsurface(rot_rect).copy()
    return rot_image
#-----------------------------------------------------------------------------------------------
def miseAJour():
    global accelere,position,vitesse,direction,acceleration_angulaire,vitesse_angulaire
    if tourneAGauche:
       direction = direction - vitesse_angulaire
       print direction
    if tourneADroite:
        direction = direction + vitesse_angulaire
        print direction
    if accelere:
		#mise à jour de la vitesse
		vitesse   = [vitesse[0] +vecteurAcceleration(direction)[0],vitesse[1]+vecteurAcceleration(direction)[1]]
		
		#mise à jour de la position
		position = [(vitesse[0] + position[0]) % LARGEUR,(vitesse[1] + position[1])%HAUTEUR]
		
    else:
		#décéleration
        vitesse   = [vitesse[0] *coefficient_friction,vitesse[1]*coefficient_friction]
		#mise à jour de la position
        position = [(vitesse[0] + position[0]) % LARGEUR,(vitesse[1] + position[1]) % HAUTEUR]			   
#------------------------------------------------------------------------------ 			   
#------------------------------------------------------------------------------ 

# --------------------PROGRAMME PRINCIPAL--------------------------------
#Initialisation de pygame
pygame.init()

#Initialisation de la fenetre graphique
fenetre = pygame.display.set_mode((LARGEUR,HAUTEUR))
pygame.display.set_caption("Vaisseau")

#chargement des images en mémoire vive
#fonds écran = espace
image_espace = pygame.image.load("space.png")

# vaisseau_off
image_Vaisseau_off = pygame.image.load("ship_off.png")

# vaisseau_on
image_Vaisseau_on = pygame.image.load("ship_on.png")
#son  = pygame.mixer.music;load
   
#boucle infinie
while True:

#receptionnaire evenements
    for event in pygame.event.get():
        if event.type == QUIT:
            pygame.quit()
            sys.exit()
        elif event.type == KEYDOWN:
            if event.key == K_UP:
                accelere = True
            if event.key == K_LEFT:
				tourneAGauche = True
            if event.key == K_RIGHT:
				tourneADroite = True
        elif event.type == KEYUP:
        	if event.key == K_UP:
        		accelere = False
        	if event.key == K_LEFT:
        		tourneAGauche = False
        	if event.key == K_RIGHT:
        		tourneADroite = False

#mise à jour
    miseAJour()
#rotation de l'image de 45°
    #image_tournee = pygame.transform.rotate(image_Vaisseau, direction)
    
#intégration de l'image fonds écran à la fenêtre
    fenetre.blit(image_espace,(0,0))
    if accelere:
    	image_tournee_on = rot_center(image_Vaisseau_on,-direction)
        fenetre.blit(image_tournee_on,(position[0],position[1]))
    else:
    	image_tournee_off = rot_center(image_Vaisseau_off,-direction)
        fenetre.blit(image_tournee_off,(position[0],position[1]))
    	
#intégration de l'image du vaisseau à l'écran
    
    pygame.display.update()		
   
#------------------------------------------------------------------------------------------
